-- name: \\#FFECED\\[CS] \\#912B26\\G\\#FFECED\\uilty \\#912B26\\G\\#FFECED\\ear \\#FFECED\\Pack
-- description: A collection of Guilty Gear characters!!\n\n\\#912B26\\This Pack requires Character Select\nby 6b

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local TEXT_MOD_NAME = "Guilty Gear Pack"
local TEXT_MOD_VERSION = "Release 1"
if not _G.charSelectExists then
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
    return 0
end

local TEX_ELPHELT_ICON = get_texture_info("elphelt_icon")
local TEX_FAUST_ICON = get_texture_info("faust_icon")

local VOICETABLE_ELPHELT = {
    [CHAR_SOUND_ATTACKED] = "elphelt_attacked.ogg",
    [CHAR_SOUND_GROUND_POUND_WAH] = "elphelt_yah.ogg",
    [CHAR_SOUND_HAHA] = "elphelt_haha.ogg",
    [CHAR_SOUND_HAHA_2] = "elphelt_haha.ogg",
    [CHAR_SOUND_HERE_WE_GO] = "elphelt_herewego.ogg",
    [CHAR_SOUND_HOOHOO] = "elphelt_hoo.ogg",
    [CHAR_SOUND_ON_FIRE] = "elphelt_burning.ogg",
    [CHAR_SOUND_OOOF] = "elphelt_oof.ogg",
    [CHAR_SOUND_OOOF2] = "elphelt_oof2.ogg",
    [CHAR_SOUND_PUNCH_HOO] = "elphelt_hoo.ogg",
    [CHAR_SOUND_PUNCH_WAH] = "elphelt_wah.ogg",
    [CHAR_SOUND_PUNCH_YAH] = "elphelt_yah.ogg",
    [CHAR_SOUND_SO_LONGA_BOWSER] = "elphelt_solonga.ogg",
    [CHAR_SOUND_TWIRL_BOUNCE] = "elphelt_Jump.ogg",
    [CHAR_SOUND_WAAAOOOW] = "elphelt_hurthard.ogg",
    [CHAR_SOUND_WAH2] = "elphelt_wah2.ogg",
    [CHAR_SOUND_WHOA] = "elphelt_wah2.ogg",
    [CHAR_SOUND_YAHOO] = "elphelt_dipi.ogg",
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"elphelt_dipi.ogg", "elphelt_yippie.ogg"},
    [CHAR_SOUND_YAH_WAH_HOO] = {"elphelt_yah.ogg", "elphelt_wah.ogg", "elphelt_hoo.ogg"},
    [CHAR_SOUND_OKEY_DOKEY] = "elphelt_ok.ogg",
    [CHAR_SOUND_LETS_A_GO] = "elphelt_letsgo.ogg",
    [CHAR_SOUND_DYING] = "elphelt_dying.ogg",
    [CHAR_SOUND_DROWNING] = "elphelt_dying.ogg",
    [CHAR_SOUND_EEUH] = "elphelt_pickup.ogg",
    [CHAR_SOUND_MAMA_MIA] = "elphelt_mammamia.ogg",
    [CHAR_SOUND_DOH] = "elphelt_oof.ogg",
    [CHAR_SOUND_HRMM] = "elphelt_pickup.ogg",
    [CHAR_SOUND_PANTING] = "elphelt_pant.ogg",
    [CHAR_SOUND_UH] = "elphelt_oof2.ogg",
    [CHAR_SOUND_UH2] = "elphelt_oof.ogg",
    [CHAR_SOUND_UH2_2] = "elphelt_oof2.ogg"
}
local VOICETABLE_FAUST = {
  [CHAR_SOUND_ATTACKED] = "faustx_attacked.ogg",
  [CHAR_SOUND_DOH] = "faustx_hithard.ogg",
  [CHAR_SOUND_DROWNING] = "faustx_drown.ogg",
  [CHAR_SOUND_DYING] = "faustx_dead.ogg",
  [CHAR_SOUND_GROUND_POUND_WAH] = "faustx_hithard.ogg",
  [CHAR_SOUND_HAHA] = "faustx_haahaa.ogg",
  [CHAR_SOUND_HAHA_2] = "faustx_haahaa.ogg",
  [CHAR_SOUND_HERE_WE_GO] = "faustx_herewego.ogg",
  [CHAR_SOUND_HOOHOO] = {"faustx_jump1.ogg", "faustx_jump1.ogg", "faustx_jump1.ogg"},
  [CHAR_SOUND_MAMA_MIA] = "faustx_ok.ogg",
  [CHAR_SOUND_OKEY_DOKEY] = "faustx_ok.ogg",
  [CHAR_SOUND_ON_FIRE] = "faustx_burning.ogg",
  [CHAR_SOUND_OOOF] = "faustx_hahoff.ogg",
  [CHAR_SOUND_OOOF2] = "faustx_hahoff.ogg",
  [CHAR_SOUND_PUNCH_HOO] = "faustx_punch3.ogg",
  [CHAR_SOUND_PUNCH_WAH] = "faustx_punch2.ogg",
  [CHAR_SOUND_PUNCH_YAH] = "faustx_punch1.ogg",
  [CHAR_SOUND_SO_LONGA_BOWSER] = "faustx_solonga.ogg",
  [CHAR_SOUND_TWIRL_BOUNCE] = "faustx_shuaboing.ogg",
  [CHAR_SOUND_WAAAOOOW] = "faustx_FallingGreatHeight.ogg",
  [CHAR_SOUND_WAH2] = "faustx_jump1.ogg",
  [CHAR_SOUND_WHOA] = "faustx_hahoff.ogg",
  [CHAR_SOUND_YAHOO] = "faustx_longjump.ogg",
  [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = {"faustx_longjump.ogg","faustx_jump3.ogg"},
  [CHAR_SOUND_YAH_WAH_HOO] = {"faustx_jump1.ogg", "faustx_punch1.ogg", "faustx_shuaboing.ogg"},
  [CHAR_SOUND_YAWNING] = "silence.ogg",
  [CHAR_SOUND_PANTING] = "faustx_grab.ogg",
  [CHAR_SOUND_COUGHING1] = "silence.ogg",
  [CHAR_SOUND_COUGHING2] = "silence.ogg",
  [CHAR_SOUND_COUGHING3] = "silence.ogg",
  [CHAR_SOUND_MAMA_MIA] = "faustx_ok.ogg",
  [CHAR_SOUND_IMA_TIRED] = "faustx_hahoff.ogg",
  [CHAR_SOUND_LETS_A_GO] = "faustx_letsgo.ogg",
  [CHAR_SOUND_HRMM] = "faustx_pickup.ogg",
  [CHAR_SOUND_UH2] = "faustx_pickup.ogg",
  [CHAR_SOUND_UH2_2] = "faustx_grab.ogg",
  [CHAR_SOUND_UH] = "faustx_hrm.ogg",
  [CHAR_SOUND_PANTING_COLD] = "faustx_grab.ogg",
  [CHAR_SOUND_SNORING1] = "silence.ogg",
  [CHAR_SOUND_SNORING2] = "silence.ogg",
  [CHAR_SOUND_SNORING3] = "silence.ogg",
  [CHAR_SOUND_EEUH] = "faustx_pickup.ogg"
}
-- Load Models
local E_MODEL_ELPHELT = smlua_model_util_get_id("elphelt_geo")
local E_MODEL_ELPHELTJACK = smlua_model_util_get_id("elpheltjack_geo")
local E_MODEL_FAUSTXRD = smlua_model_util_get_id("faustxrd_geo")
local E_MODEL_FAUSTXX = smlua_model_util_get_id("faustxx_geo")


-- Character Initialize
local CT_ELPHELT = _G.charSelect.character_add("Elphelt", {"The romantic rascal."}, "Model by Vichi. VA: Aya Suzaki", {r = 235, g = 174, b = 196}, E_MODEL_ELPHELT, CT_MARIO, TEX_ELPHELT_ICON)
local CT_FAUST = _G.charSelect.character_add("Faust", {"The Dark Wandering Doctor."}, "Model by Vichi. VA: Takashi Kondo", {r = 121, g = 151, b = 97}, E_MODEL_FAUSTXRD, CT_MARIO, TEX_FAUST_ICON)

-- Add Voices
_G.charSelect.character_add_voice(E_MODEL_ELPHELT, VOICETABLE_ELPHELT)
_G.charSelect.character_add_voice(E_MODEL_ELPHELTJACK, VOICETABLE_ELPHELT)
_G.charSelect.character_add_voice(E_MODEL_FAUSTXRD, VOICETABLE_FAUST)
_G.charSelect.character_add_voice(E_MODEL_FAUSTXX, VOICETABLE_FAUST)

 -- Update Voicelines
local character_get_voice, update_sound, update_snore = _G.charSelect.character_get_voice, _G.charSelect.voice.sound, _G.charSelect.voice.snore
local function character_sounds(m, sound)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_ELPHELT
    or v == VOICETABLE_FAUST
    then
        return update_sound(m, sound)
    end
end
local function character_snore(m)
    local v = _G.charSelect.character_get_voice(m)
    if v == VOICETABLE_ELPHELT
    or v == VOICETABLE_FAUST
    then
        return update_snore(m)
    end
end

hook_event(HOOK_CHARACTER_SOUND, character_sounds)
hook_event(HOOK_MARIO_UPDATE, character_snore)

    -- table of skins
    local SKINTABLE_FAUST = {
        { model = E_MODEL_FAUSTXX,  name = "Faust",    desc = { "The Dark Wandering Doctor." , "XX Design" },          color = { r = 95, g = 81, b = 145 } }
    }

    for index, alt in ipairs(SKINTABLE_FAUST) do
        _G.charSelect.character_add_costume(CT_FAUST, nil, alt.desc, nil, alt.color, alt.model, nil, nil, nil, nil)
    end
    local SKINTABLE_ELPHELT = {
        { model = E_MODEL_ELPHELTJACK,  name = "Elphelt",    desc = { "The romantic rascal." , "Without Jacket" },          color = {r = 235, g = 174, b = 196 } }
    }

    for index, alt in ipairs(SKINTABLE_ELPHELT) do
        _G.charSelect.character_add_costume(CT_ELPHELT, nil, alt.desc, nil, alt.color, alt.model, nil, nil, nil, nil)
    end
